"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

(function (window) {
  var ENVIRONMENTS = Object.freeze({ BROWSER: 0, NODE: 1, UNKNOWN: 2 });

  // Detect whether instance is ran in browser or on node js
  var ENV = (typeof window === "undefined" ? "undefined" : _typeof(window)) === "object" && _typeof(window.document) === "object" ? ENVIRONMENTS.BROWSER : (typeof module === "undefined" ? "undefined" : _typeof(module)) === "object" && module && _typeof(module.exports) === "object" ? ENVIRONMENTS.NODE : ENVIRONMENTS.UNKNOWN;

  var NetworkError = function (_Error) {
    _inherits(NetworkError, _Error);

    function NetworkError(message, status, statusText, headers) {
      _classCallCheck(this, NetworkError);

      var _this = _possibleConstructorReturn(this, (NetworkError.__proto__ || Object.getPrototypeOf(NetworkError)).call(this, message));

      _this.name = _this.constructor.name;
      _this.response = status !== undefined || statusText !== undefined ? { status: status, statusText: statusText, headers: headers } : null;
      _this.request = true;
      if (typeof Error.captureStackTrace === "function") {
        Error.captureStackTrace(_this, _this.constructor);
      } else {
        _this.stack = new Error(message).stack;
      }
      return _this;
    }

    return NetworkError;
  }(Error);

  var Regrest = function () {
    function Regrest() {
      _classCallCheck(this, Regrest);

      switch (ENV) {
        case ENVIRONMENTS.BROWSER:
          this.requestAdapter = browserRequest.bind(this);
          break;
        case ENVIRONMENTS.NODE:
          this.nodeAdapters = {
            http: require("http"),
            https: require("https")
          };
          this.requestAdapter = nodeRequest.bind(this);
          break;
        default:
          throw new NetworkError("Unsupported environment");
      }
    }

    _createClass(Regrest, [{
      key: "request",
      value: function request(_ref) {
        var _ref$method = _ref.method,
            method = _ref$method === undefined ? "GET" : _ref$method,
            url = _ref.url,
            _ref$headers = _ref.headers,
            headers = _ref$headers === undefined ? {} : _ref$headers,
            params = _ref.params,
            _ref$data = _ref.data,
            data = _ref$data === undefined ? null : _ref$data;

        // Generate query string and join it with url
        url = "" + url + (params ? "?" + Object.entries(params).map(function (_ref2) {
          var _ref3 = _slicedToArray(_ref2, 2),
              key = _ref3[0],
              value = _ref3[1];

          return key + "=" + value;
        }).join("&") : "");
        return this.requestAdapter(method, url, data, headers);
      }

      // Convenience methods

    }, {
      key: "get",
      value: function get(url, config) {
        return this.request(_extends({}, config, { url: url }));
      }
    }, {
      key: "head",
      value: function head(url, config) {
        return this.request(_extends({}, config, { method: "HEAD", url: url }));
      }
    }, {
      key: "post",
      value: function post(url, data, config) {
        return this.request(_extends({}, config, { method: "POST", url: url, data: data }));
      }
    }, {
      key: "put",
      value: function put(url, data, config) {
        return this.request(_extends({}, config, { method: "PUT", url: url, data: data }));
      }
    }, {
      key: "delete",
      value: function _delete(url, config) {
        return this.request(_extends({}, config, { method: "DELETE", url: url }));
      }
    }, {
      key: "options",
      value: function options(url, config) {
        return this.request(_extends({}, config, { method: "OPTIONS", url: url }));
      }
    }, {
      key: "patch",
      value: function patch(url, data, config) {
        return this.request(_extends({}, config, { method: "PATCH", url: url, data: data }));
      }
    }]);

    return Regrest;
  }();

  // Export


  if ((typeof module === "undefined" ? "undefined" : _typeof(module)) === "object" && module && _typeof(module.exports) === "object") {
    /**
     * Expose Regrest as module.exports in loaders
     * that implement the Node module pattern (including browserify)
     */
    module.exports = new Regrest();
  } else {
    // Otherwise expose Regrest to the global object
    window.regrest = new Regrest();
  }

  // Unexposed helper methods and adapters
  function browserRequest(requestType, url, body, headers) {
    return new Promise(function (resolve, reject) {
      var request = new XMLHttpRequest();
      request.open(requestType, url, true);
      Object.entries(headers).forEach(function (_ref4) {
        var _ref5 = _slicedToArray(_ref4, 2),
            key = _ref5[0],
            value = _ref5[1];

        return request.setRequestHeader(key, value);
      });
      request.onload = function () {
        var headers = _extends({}, this.getAllResponseHeaders().trim().split(/[\r\n]+/).map(function (header) {
          return header.split(": ");
        }).map(function (_ref6) {
          var _ref7 = _slicedToArray(_ref6, 2),
              key = _ref7[0],
              value = _ref7[1];

          return _defineProperty({}, key, value);
        }));
        if (this.status >= 200 && this.status < 400) {
          resolve({
            status: this.status,
            statusText: this.statusText,
            headers: headers,
            text: this.responseText,
            get json() {
              return JSON.parse(this.text);
            }
          });
        } else {
          reject(new NetworkError(this.status + " " + this.statusText, this.status, this.statusText, headers));
        }
      };
      request.onerror = function () {
        reject(new NetworkError("connection error"));
      };
      request.send(body);
    });
  }

  function nodeRequest(requestType, url, body, headers) {
    var _this2 = this;

    return new Promise(function (resolve, reject) {
      var parsedUrl = new URL(url);
      var options = {
        host: parsedUrl.host,
        path: "" + parsedUrl.pathname + parsedUrl.search,
        method: requestType,
        headers: headers
      };
      var req = _this2.nodeAdapters[parsedUrl.protocol.slice(0, -1)].request(options, function (res) {
        if (res.statusCode >= 200 && res.statusCode < 300) {
          var rawData = "";
          res.setEncoding("utf8");
          res.on("data", function (chunk) {
            return rawData += chunk;
          });
          res.on("end", function () {
            return resolve({
              status: res.statusCode,
              statusText: res.statusMessage,
              headers: res.headers,
              text: rawData,
              get json() {
                return JSON.parse(rawData);
              }
            });
          });
        } else {
          reject(new NetworkError(res.statusCode + " " + res.statusMessage, res.statusCode, res.statusMessage, res.headers));
        }
      });
      req.on("error", function (e) {
        return reject(new NetworkError(e));
      });
      body && req.write(body);
      req.end();
    });
  }
})(undefined);